//+------------------------------------------------------------------+
//|                                           Stochastic_fan_color   |
//|                                         Copyright  2012 Fox.RM  |
//|                                               fox.rm@mail.ru     |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012 Fox.RM"
#property link      "fox.rm@mail.ru"

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  Red
#property  indicator_color2  CornflowerBlue
#property  indicator_color3  Gray
#property  indicator_color4  Green
#property  indicator_width1  2
//#property indicator_style5 1
//---- basic fan indicator parameters

extern bool Show_AOLine_2=true;
extern int SlowEMA3=34;
extern int EMA=2;
//---- additional fan indicator parameters
extern bool Show_AOLine_5=true;
extern int FastEMA2=21;
extern int SlowEMA6=55;
extern bool Show_AOLine_6=true;
extern int V=34;
extern int nPeriod = 5;
//---- indicator buffers

double     AOBuffer3[];
double     EMABuffer2[];
double     VBuffer[];
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   //---- drawing settings
   
//---- 3 indicator buffers mapping
   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Awesome_fan_Volumes");
   
   
//---- AO_fan line 2 (basic)
   if(Show_AOLine_2 ==true){Show_AOLine_2=DRAW_LINE; }
   else 
    {Show_AOLine_2=DRAW_NONE; }
   SetIndexBuffer(0,AOBuffer3);
   SetIndexStyle(0,Show_AOLine_2);
   SetIndexLabel(0,"basic line");   


//---- AO_fan line (slow trand)
 if(Show_AOLine_5 ==true){Show_AOLine_5=DRAW_LINE; }
   else 
    {Show_AOLine_5=DRAW_NONE; }
   SetIndexBuffer(1,EMABuffer2);
   SetIndexStyle(1,Show_AOLine_5);
   SetIndexLabel(1,"slow trand  ( "+FastEMA2+" )( "+SlowEMA6+" )");

//---- AO_fan V Line (balans)
 if(Show_AOLine_6 ==true){Show_AOLine_6=DRAW_LINE; }
   else 
    {Show_AOLine_6=DRAW_NONE; }
   SetIndexBuffer(2,VBuffer);
   SetIndexStyle(2,Show_AOLine_6);
   SetIndexLabel(2,"balans line (V)  ( "+V+" )");
   
   SetIndexBuffer(3,ExtMapBuffer1);
   SetIndexStyle(3,DRAW_HISTOGRAM);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Awesome Oscillator                                               |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

//---- AO_fan line 2 (basic) buffer
   for(int i=0; i<limit; i++)
   {
      AOBuffer3[i]=iMA(NULL,0,EMA,0,MODE_SMA,PRICE_MEDIAN,i)-iMA(NULL,0,SlowEMA3,0,MODE_SMA,PRICE_MEDIAN,i);
       int nSum = Volume[i]/nPeriod; //--     Volumes
       if (AOBuffer3[i]<0)ExtMapBuffer1[i] = nSum;  //--    Volumes
       if (AOBuffer3[i]>0)ExtMapBuffer1[i] = -nSum; //--   Awesom (AO).

//---- AO_fan line (slow trand) buffer
   
      EMABuffer2[i]=iMA(NULL,0,FastEMA2,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA6,0,MODE_EMA,PRICE_CLOSE,i);

//---- AO_fan V Line (balans)

      VBuffer[i]=iMA(NULL,0,V,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,V,0,MODE_SMA,PRICE_MEDIAN,i);

 
//---- dispatch values between 2 buffers
   }
       
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

